unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, math;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Label3: TLabel;
    Edit3: TEdit;
    Image1: TImage;
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    nx,ny  : integer;
    px,py  : integer;

    Hoja   : TCanvas;

    AP     : array of array[0..2] of single;
    AT     : array of array[0..1] of integer;
    np,nt  : integer;

    procedure leer_datos();
    procedure dibujar();
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.leer_datos();
var
  k  : integer;
  id : TextFile;
begin
  AssignFile(id,'casa1.xyz');
  reset(id);
  readln(id);
  // puntos
  readln(id,np);
  SetLength(AP,np);
  for k := 0 to np - 1 do
    readln(id, AP[k][0],AP[k][1],AP[k][2]);
  // trazos
  readln(id);
  readln(id,nt);
  SetLength(AT,nt);
  for k := 0 to nt - 1 do
    readln(id, AT[k][0],AT[k][1]);
  CloseFile(id);  
end;

procedure TForm1.dibujar();
var
  k, p,q   : integer;
  L,phi,EE : single;
  xx,yy    : single;
  si,co    : single;
begin
  L   := StrToFloat(Edit1.Text);
  phi := StrToFloat(Edit2.Text);
  EE  := StrToFloat(Edit3.Text);
  phi := Pi*phi/180;
  si  := sin(phi); co := cos(phi);

  for k := 0 to nt - 1 do begin
    p := AT[k][0];  q := AT[k][1];
    xx := AP[p][0] -L*co*AP[p][2];
    yy := AP[p][1] -L*si*AP[p][2];

    hoja.MoveTo(px+ceil(EE*xx), py-ceil(EE*yy));

    xx := AP[q][0] -L*co*AP[q][2];
    yy := AP[q][1] -L*si*AP[q][2];

    hoja.LineTo(px+ceil(EE*xx), py-ceil(EE*yy));
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  nx := Image1.Width;
  ny := Image1.Height;

  px := nx div 2;
  py := ny div 2;

  hoja := Image1.Canvas;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  hoja.Rectangle(0,0,nx,ny);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
//
  leer_datos();
  dibujar();
end;


end.
